<!doctype html>
<!--!
%%%SIGNED_PAGES_PGP_SIGNATURE%%%
-->
<html>
	<head>
		<title>ACMEv2 sample client</title>
		<link rel="stylesheet"
			href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css"
			integrity="sha384-wvfXpqpZZVQGK6TAh5PVlGOfQNHSoD2xbE+QkPxCAFlNEevoEH3Sl0sibVcOQVnN"
			crossorigin="anonymous"/>
		<script src="js/mermaid.min.js"
			integrity="sha384-Ig7i1BiZA3DYOBmfYS/VU9eiS6nVwmSjqgvQtw3M2GJCHAGWU6+g1fu4p++S1U9q"
			crossorigin="anonymous"></script>
		<link rel="shortcut icon"
			type="image/png"
			integrity="sha384-fbHFUilH1qtiX+lSSx00eTDuach3Xc6IeNsxvb0LQk85JppWVd3Z2rgHKkUmCwnU"
			href="https://upload.wikimedia.org/wikipedia/commons/7/7c/ACME%E2%80%93protocol-icon.png" />
		<link rel="stylesheet"
			integrity="sha384-+Bjr6nLetn4Xbsdi+xGf+7UJhj9D0bW0RQehm49tIdPmSnTU4Ur4420n5DvRhByI"
			href="css/screen.css" />
		<script src="js/jsrsasign-all-min.js"
			integrity="sha384-/pC1I4kV+68RWaa4p2OIzkypG9Ni1n76jTI1MB20/G5WWiNLxWVrTTjbX4wQ72vk"
			crossorigin="anonymous"></script>

		<script src="js/sequence.js"
			integrity="sha384-nm9bY9p0WITEAOWsSoXxzJaRpiCGABbNF9RCvyhwtqctEeR9djNEkgVkpyebK91D"
			crossorigin="anonymous"></script>
		<script src="applog/script.js"
			integrity="sha384-w7K31cPgi1OYbhIfnquU9hs6nOOCRJ6z6+k4crVRB2NH+EtR/A/TVF/DnSNUE9Rz"
			crossorigin="anonymous"></script>
		<link rel="stylesheet"
			integrity="sha384-2Q6QgPMAU+7A/Tr9M6D+QEL2DoKKYlIphgmw62a+U8VeAC0zqrg9r2WC05SSnB41"
			href="applog/style.css" />
		<script src="js/acme.js"
			integrity="sha384-sCKAZSYN7DA0N0+a6Fa84tQw+MG1w45jGIH82tSxiqlG4TZRtCGhc02G8LZB0zyv"
			crossorigin="anonymous"></script>
	</head>
	<body>
		<div class="navbar">
			<script>
				function navbarClick(menu, columns) {
					document.querySelectorAll('.column').forEach((column) => {
						column.style.display = "none";
					});
					document.querySelectorAll('.navbar-menu').forEach((menu) => {
						menu.className = menu.className.replace(" active", "");
					});
					document.querySelector(menu).className += " active";
					for (let column of columns)
						document.querySelector(column).style.display = "block";
				}
			</script>
			<a class="navbar-menu" href="#" id="navbar-home" onclick="navbarClick('#navbar-home', ['#column-welcome'])"><i class="fa fa-fw fa-home"></i> Home</a>
			<a class="navbar-menu active" href="#" id="navbar-acme" onclick="navbarClick('#navbar-acme', ['#column-acme', '#column-csr'])"><i class="fa fa-fw fa-certificate"></i> ACMEv2</a>
			<a class="navbar-menu" href="#" id="navbar-settings" onclick="navbarClick('#navbar-settings', ['#column-settings'])"><i class="fa fa-fw fa-square"></i> Settings</a>
			<a class="navbar-menu" href="#"><i class="fa fa-fw fa-user"></i> Logout</a>
			<span class="search"><i class="fa fa-fw fa-search"></i> <input type="text" placeholder="Search ..." /></span>
		</div>

		<div class="alert">
			<span class="closebtn" onclick="this.parentElement.style.display='none';">&times;</span>
			<strong>Alert</strong>
			<span id="alert"></span>
		</div>

		<script>
			function addAction(action, url, desc) {
				var label = action;
				if (desc !== undefined)
					label += ` (${desc})`;
				var actions = document.querySelector("#actions");
				var id = "action-" + (actions.childElementCount - 1);
				var html = `<label for="${id}">${label}</label><br />`
					+ `<input type="button" name="${id}" onclick='${action}("${url}")' value="${url}" /><br />`;
				actions.innerHTML += html;
			}
		</script>
		<script>
			/* user experience */
			function displayAlert(str) {
				var e = document.getElementById("alert");
				e.innerHTML = str;
				e.parentElement.style.display = "block";
				setTimeout(() => { e.parentElement.style.display = "none"; }, 10000);
			}
			function toggle(str) {
				var e = document.querySelector(str);
				if (e.style.display != "none")
					e.style.display = "none";
				else
					e.style.display = "block";
			}
		</script>

		<div>
			<form>
				<div class="row">
					<div class="column" id="column-welcome" style="display: none;">
						<fieldset>
							<legend>Certification authority</legend>
						</fieldset>
					</div>
					<div class="column" id="column-acme">
						<fieldset>
							<legend>ACMEv2 requests</legend>
							<fieldset>
								<legend>Account</legend>
								<label for="laccountContact">E-Mail address</label><br />
								<input name="laccountContact" type="text" id="laccountContact" value="mailto:admin@example.com" size="64" width="64" /><br />
								<input name="lagreedToTerms" type="checkbox" id="lagreedToTerms" checked="true" />
								<label for="lagreedToTerms">Agree to terms of service</label><br />
								<fieldset>
									<legend>External account binding (EAB)</legend>
									<label for="leabKid">KID</label><br />
									<input name="leabKid" type="input" id="leabKid" size="64" width="64" /><br />
									<label for="leabHmac">HMAC key</label><br />
									<input name="leabHmac" type="password" id="leabHmac" size="64" width="64" /><br />
								</fieldset>
								<label for="lnewAccount">newAccount</label><br />
								<input name="lnewAccount" type="button" onclick="newAccount([document.getElementById('laccountContact').value], document.getElementById('lagreedToTerms').value === 'on', document.getElementById('leabKid').value, document.getElementById('leabHmac').value)" value="newAccount" />
								<input name="lrecoverAccount" type="button" onclick="recoverAccount()" value="recoverAccount" /><br />
							</fieldset>

							<fieldset>
								<legend>Order</legend>
								<fieldset>
									<legend>Identifier</legend>
									<label for="ltype">Type</label>
									<select name="ltype" id="ltype" type="select">
										<option value="email">email</option>
										<option value="dns" selected="selected">dns</option>
										<option value="ip">ip</option>
									</select><br />
									<label for="lvalue">Domain / E-Mail</label>
									<input name="lvalue" id="lvalue" type="text" value="example.com" placeholder="www.example.com" size="48" width="128" />
								</fieldset>
 								<label for="lnewOrder">newOrder</label><br />
								<input name="lnewOrder" type="button" onclick="newOrder(document.getElementById('ltype').value)" value="newOrder" /><br />
								<input name="lstar" type="checkbox" id="lstar" />
								<label for="lstar">STAR certificate</label><br />
								<label for="lstatus">Request status</label><br />
								<input name="lstatus" type="button" onclick="getStatus(updateStatus)" value="Status" />
							</fieldset>

							<fieldset>
								<legend>Certificate</legend>
								<label for="lcertonly">Request certificate</label><br />
								<input name="lcertonly" type="button" onclick="clickCertonly()" value="Request" /><br />
								<script>
									async function clickCertonly() {
										let chain = await certonly(document.querySelector('#ldirectory').value,
											[document.querySelector('#laccountContact').value],
											document.querySelector('#lagreedToTerms').value === 'on',
											document.querySelector('#lchallenge').value,
											document.querySelector('#lcsr').value);
										if (chain !== undefined) {
											document.querySelector('#lpem').value = chain;
											link = document.querySelector("#chain");
											link.href = `data:text/plain;charset=utf-8,${encodeURIComponent(chain)}`;
											link.style.display = "inline";
											link.click();
											document.querySelector('#column-csr').style.display = "none";
											document.querySelector('#column-certificate').style.display = "block";
										}
									}
								</script>
								<label for="lrevokeCert">Revoke certificate</label><br />
								<select name="lreason" id="lreason" type="select">
									<option value="1">keyCompromise</option>
									<option value="2">cACompromise</option>
									<option value="3">affiliationChanged</option>
									<option value="4" selected="selected">superseeded</option>
									<option value="5">cessationOfOperation</option>
									<option value="6">certificateHold</option>
									<option value="7">privilegeWithdrawn</option>
									<option value="8">aACompromise</option>
								</select>
								<input name="lrevokeCert" type="button" onclick="clickRevokeCert()" value="revokeCert" /><br />
								<script>
									function clickRevokeCert() {
										return revokeCert(
											document.querySelector("#lpem").value,
											parseInt(document.querySelector("#lreason").value)
										);
									}
								</script>
							</fieldset>
						</fieldset>
					</div>
					<div class="column" id="column-csr" style="display: block;">
						<fieldset>
							<legend>Certification request</legend>
							<fieldset>
								<legend>Key generation</legend>
								<label for="lkey">Private key (JWK)</label><br />
								<textarea name="lkey" id="lkey" type="text" cols="68" rows="7" placeholder='{
		"kty": "EC",
		"crv": "P-256",
		"x": "vHcOkaNQGpUbm9XxsAaYYrNn0Atx1I7t4BhWnoLEkwg",
		"y": "JFhOiUDnh3GDizHT0IRA84kkhvOzCUQVnNjPnGccO6k",
		"d": "yr2YI5WBUIyeu0dmjfA61lKTkvI_LgESPx7SHayCkxI"
}'></textarea><br />
								<label for="lcsrAlgorithm">Algorithm</label>
								<select name="lcsrAlgorithm" id="lcsrAlgorithm" type="select">
									<option value="RSA-2048">RSA 2048</option>
									<option value="RSA-3072">RSA 3072</option>
									<option value="RSA-4096">RSA 4096</option>
									<option value="P-256" selected="selected">ECDSA (P-256)</option>
									<option value="P-384">ECDSA (P-384)</option>
									<option value="Ed25519">Ed25519</option>
								</select><br />
								<input name="lgencsrkey" type="button" onclick="clickGenerateCSRKey()" value="Generate CSR key" />
								<script>
									function clickGenerateCSRKey() {
										document.querySelector('#lkey').value = generateCSRKey();
									}
								</script>
								<label for="lgencsrkey">Generate CSR key</label>
							</fieldset>
							<fieldset>
									<legend>Certificate Signing Request (CSR) generation</legend>
 									<label for="lcsr">Certificate Signing Request (CSR)</label><br />
									<textarea name="lcsr" id="lcsr" type="text" cols="68" rows="10" placeholder='-----BEGIN CERTIFICATE REQUEST-----
MIH6MIGhAgEAMBYxFDASBgNVBAMMC2V4YW1wbGUuY29tMFkwEwYHKoZIzj0CAQYI
KoZIzj0DAQcDQgAEvHcOkaNQGpUbm9XxsAaYYrNn0Atx1I7t4BhWnoLEkwgkWE6J
QOeHcYOLMdPQhEDziSSG87MJRBWc2M+cZxw7qaApMCcGCSqGSIb3DQEJDjEaMBgw
FgYDVR0RBA8wDYILZXhhbXBsZS5jb20wCgYIKoZIzj0EAwIDSAAwRQIhAPWw5WF0
71nNcSW3/jx05oJH+5fz0B29xBJSV/0ZH91aAiAzExtLwTKRSFVZ/JPuAFi3MlMR
texe1Lm17ZerliFEIQ==
-----END CERTIFICATE REQUEST-----'></textarea><br />
									<label for="lcsrHash">Hash</label>
									<select name="lcsrHash" id="lcsrHash" type="select">
										<option value="SHA1">SHA-1</option>
										<option value="SHA224">SHA-224</option>
										<option value="SHA256" selected="selected">SHA-256</option>
										<option value="SHA384">SHA-384</option>
										<option value="SHA512">SHA-512</option>
									</select><br />
									<input name="lgencsr" type="button" onclick="clickGenerateCSR()" value="Generate CSR" />
									<label for="lgencsr">Generate CSR</label>
									<script>
										function clickGenerateCSR() {
											let jwk = document.querySelector("#lkey").value;
											let type = document.querySelector("#ltype").value;
											let value = document.querySelector("#lvalue").value;
											document.querySelector("#lcsr").value = generateCSR(jwk, type, value);
										}
										document.addEventListener("DOMContentLoaded", (event) => {
											clickGenerateCSRKey();
											clickGenerateCSR();
										});
									</script>
								</fieldset>
						</fieldset>
					</div>
					<div class="column" id="column-certificate" style="display: none;">
						<fieldset>
							<legend>Certificate chain</legend>
 							<label for="lpem">Certificate chain (x509)</label>
							<a href="" id="chain" download="chain.pem" style="display: none;">Download</a> <br />
							<textarea name="lpem" id="lpem" type="text" cols="68" rows="10"></textarea>
						</fieldset>
					</div>
					<div class="column" id="column-settings" style="display: none;">
						<fieldset>
							<legend>ACMEv2 account key</legend>
							<fieldset>
								<legend>Key management</legend>
								<label for="lcreateAccountKey">createAccountKey</label><br />
								<input name="lcreateAccountKey" type="button" onclick="createAccountKey()" value="createAccountKey" /><br />
								<label for="lsaveAccountKey">saveAccountKey</label><br />
								<input name="lsaveAccountKey" type="button" onclick="saveAccountKey()" value="saveAccountKey" /><br />
								<label for="lloadAccountKey">loadAccountKey</label><br />
								<input name="lloadAccountKeyValue" id="lloadAccountKeyValue" type="input" placeholder="JWK" />
								<input name="lloadAccountKey" type="button" onclick="loadAccountKey()" value="loadAccountKey" /><br />
							</fieldset>
							<fieldset>
								<legend>Cryptography</legend>
								<label for="lalgorithm">Algorithm</label><br />
								<select name="lalgorithm" id="lalgorithm" type="select">
									<option value="RSASSA-PKCS1-v1_5">RSASSA-PKCS1-v1_5</option>
									<option value="P-256" selected="selected">ECDSA (P-256)</option>
									<option value="P-384">ECDSA (P-384)</option>
									<option value="P-521">ECDSA (P-521)</option>
								</select><br />
								<label for="lhash">Hash</label><br />
								<select name="lhash" id="lhash" type="select">
									<option value="SHA-1">SHA-1</option>
									<option value="SHA-224">SHA-224</option>
									<option value="SHA-256" selected="selected">SHA-256</option>
									<option value="SHA-384">SHA-384</option>
									<option value="SHA-512">SHA-512</option>
								</select><br />
							</fieldset>
						</fieldset>
						<fieldset>
							<legend>ACMEv2 directory</legend>
							<label for="ldirectory">Directory</label><br />
							<input name="ldirectory" id="ldirectory" type="url" value="https://nodejs.rz-bsd.my.corp/acme/Sub/" size="64" width="64" /><br />
							<script>
								document.getElementById('ldirectory').value = `https://${window.location.host}/acme/Sub/directory`;
							</script>
							<label for="lgetDirectory">getDirectory</label><br />
							<input name="lgetDirectory" type="button" onclick="getDirectory(document.querySelector('#ldirectory').value)" value="getDirectory" /><br />
							<label for="lnewNonce">newNonce</label><br />
							<input name="lnewNonce" type="button" onclick="newNonce()" value="newNonce" /><br />
							<label for="lchallenge">Challenge</label><br />
							<select name="lchallenge" id="lchallenge" type="select">
								<option value="x-admin-01" selected="selected">x-admin-01</option>
								<option value="dns-01">dns-01</option>
								<option value="http-01">http-01</option>
							</select><br />
						</fieldset>
						<fieldset>
							<legend>Display</legend>
							<label for="lsequenceAppend">Mermaid</label>
							<input name="lsequenceAppend" id="lsequenceAppend" type="button" onclick="sequenceReset()" value="sequenceAppend" /><br />
							<input name="lmermaidEnabled" type="checkbox" onclick="toggle('#mermaid')" />
							<label for="lmermaid">Sequence diagram</label><br />
							<input name="lactions" type="checkbox" onclick="toggle('#actions')" />
							<label for="lactions">Actions</label><br />
							<input name="llog" type="checkbox" onclick="toggle('#log-tab')" />
							<label for="llog">Application log</label><br />
						</fieldset>
					</div>
				</div>
			</form>
		</div>

		<div id="actions" style="display: none;">
			<h2>Actions</h2>
		</div>

		<div>
			<script>
				function updateStatus(orders) {
					var html = "";
					for (let order of orders) {
						html += `<li><span class="caret">Order expires ${order.expires} (${order.status})</span><ul class="nested">`;
						for (let authorization of order.authorizations) {
							html += `<li><span class="caret"><i class="fa fa-fw fa-tasks"></i> Authorization for ${authorization.identifier.value} (${authorization.status})</span><ul class="nested">`;
							for (let challenge of authorization.challenges) {
								html += `<li onclick="getChallenge('${challenge.url}')"><i class="fa fa-fw fa-external-link"></i> ${challenge.type} challenge (${challenge.status})</li>`;
							}
							html += '</ul></li>';
						}
						html += '</ul></li>';
					}
					document.getElementById("orders").innerHTML = html;
					var toggler = document.getElementsByClassName("caret");
					for (let element of toggler) {
						element.addEventListener("click", function() {
							this.parentElement.querySelector(".nested").classList.toggle("opened");
							this.classList.toggle("caret-down");
						});
					}
				}
			</script>
			<h2 onclick="getStatus(updateStatus)">Status</h2>
			<ul id="orders">
			</ul>
		</div>
	</body>
</html>
